
bilin.createConstraints <- function(E, Cest)
{
    # Get the problem dimensions
    nexp <- ncol(E)
    n <- nrow(E)

	# Generate the index matrix for use in accessing columns of 
	# the constraint matrix A
	P <- matrix(0,2,0)
	for (i in 1:n)
	{
		for (j in 1:n)
		{
			P <- cbind(P,c(i,j))
		}
	}

	# Initialize (no rows yet, will get them with cbind)
	A <- matrix(0,0,n*n)
	bvec <- matrix(0,0,1)

	# Go through all the experiments
	for (ei in 1:nexp)
	{
		# Get the experimental indices 
		evec <- (E[,ei]==2)
		eveci <- which(evec)
		evecni <- which(!evec)
		evecobs <- (E[,ei]==1)
		evecobsi <- which(evecobs)
		evecnothidden <- (E[,ei]>0)
		evecnothiddeni <- which(evecnothidden)    	
		
		# Create a dummy covariance matrix with zeros for everything
		# we don't observe (i.e. do the index-manipulation stuff here)
		Callthis <- matrix(0,n,n)
		Cestthis <- Cest[[ei]]
		for (eini in 1:length(evecnothiddeni))
		{
			for (einj in 1:length(evecnothiddeni))
			{
				Callthis[evecnothiddeni[eini],evecnothiddeni[einj]] <- 
					Cestthis[eini,einj]
			}
		}
	
		# Now add all the equations corresponding to this experiment
		for (i in eveci)
		{
			for (j in evecobsi)
			{
				a <- rep(0,n*n)
				a[bilin.pair2lin(P,i,j)] <- -1
				for (k in eveci) 
				{
					a[bilin.pair2lin(P,i,k)] <- Callthis[j,k]
				}
				b <- 0
				A <- rbind(A,a)
				bvec <- rbind(bvec,b)
			}
		}
	}
	
	# Return the result as a matrix K which holds the constraint
	K <- A
	K
	
}
