bilin.matricize <- function( x ) 
{
  # Get the number of variables
  n <- round(sqrt(length(x)))
  
  # Check to make sure it is square
  if (length(x) != n*n)
  {
    stop('The vector does not turn into a square matrix!')
  }
  
  # Create the matrix and fill it out
  # (note: fill out the matrix column-wise, i.e. start with the
  # leftmost column from top to bottom, then the second column
  # from top to bottom, etc)
  A <- matrix(0,n,n)
  k <- 0
  for (j in 1:n)
  {
    for (i in 1:n)
    {
      k <- k+1
      A[i,j] <- x[k]
    }
  }
  
  A
}

