casestudy<-function() {
  #Runs the inference in the case study example in the paper.
  #This is all in infinite sample limit, so no randomness is used.

  n<-4
  #defining the model
  M<-list()
  M$B<-matrix( c(0,-0.8,0,0,
                0.5,0,0,0,
                0,0,0,0,
                0,0.3,0,0),c(4,4),byrow=TRUE )

  M$Ce<-matrix( c(1.1,0,0,0.1,
                0,1.2,0,0,
                0,0,1.3,-0.4,
                0.1,0,-0.4,1.4),c(4,4),byrow=TRUE )

  #the two experiments
  EXP<-matrix( c(1,0,-1,0,
               -1,0,0,0 ),c(2,4),byrow=TRUE )


  DATA<-list()

  for ( i in 1:nrow(EXP)) {
    e<-EXP[i,]
    cat('Creating data from experiment: {',which(e==(1)),'},{',which(e==(0)),'},{',which(e==(-1)),'}\n')
    #CREATE DATA FOR THE EXPERIMENT
    DATA[[i]]<-list(Cx=experiment.canonical(M,EXP[i,])$Cx,N=Inf,e=EXP[i,])
    print(DATA[[i]]$Cx)
  }
  cat('\n')

  T<-createParameterTable(n)
  true_values<-rep(NA,nrow(T))
  #should here test how good the found values are
  for ( t in 1:nrow(T) ) {
    true_values[t]<-experiment.canonical(M,dec.to.bin(T[t,4],n))$Cx[T[t,3],T[t,2]]
  }


#  K<-LinearInference(DATA,true_values=true_values,times=1)
  K<-lininf(DATA,true_values=true_values,times=1) #times=1, so no resampling rounds

  B<-knowledge.to.B(K)
  
  cat('Found graph structure matrix (-1=unknown):\n')
  print(B)

  cat('True model was:\n')
  print(M)


  #still producing the marginalized models in the two experiments
  cat('Experiments and marginalized models were:\n')
  for ( i in 1:nrow(EXP)) {
    e<-EXP[i,]
    cat('{',which(e==(1)),'},{',which(e==(0)),'},{',which(e==(-1)),'}\n')
    J<-diag(e==1);U<-diag(e==0);L<-diag(e==(-1));

    #first marginalize
    B<-M$B[e!=(-1),e!=(-1)]+M$B[e!=(-1),e==(-1)]%*%mpinv(diag(sum(e==(-1)))-M$B[e==(-1),e==(-1)])%*%M$B[e==(-1),e!=(-1)]
    Ce<-(diag(nrow(B))-B)%*%(mpinv(diag(nrow(M$B))-M$B)%*%M$Ce%*%t(mpinv(diag(nrow(M$B))-M$B)))[e!=(-1),e!=(-1)]%*%t(diag(nrow(B))-B)
    J<-J[e!=(-1),e!=(-1)];
    U<-U[e!=(-1),e!=(-1)];
    #then intervene
    B<-U%*%B
    Ce<-J+U%*%Ce%*%U
    print(B)
    print(Ce)
    #browser()
  }


}