data.get<-function(i, only_model=FALSE) {

  #i 	index from 1:100 for get a model and data
  #only_model	if true no sample data or covariance matrices are created
  #		for the use of result calculation
  #The following global variables are used as input:
  #	globalSanity,globalExp,globalVars,globalSamples

  #Returns a list with
  #     $model$B true model B matrix
  #     $model$Ce true model Ce matrix
  #     $E a matrix each ROW is an experiment
  #     $Cx is a list of true covariance matrices
  #     $X is a list of sample data matrices
  #     $Cx_sample list of sample covariance matrices calculated from X
  # Notice that in all structures all unobserved are marked with NA!


  if ( length(i) != 1 || i == 0 ) 
  { 
    cat('Cannot get that model!\n')
  }

  L<-list() # a list of the different things to return
  set.seed(i)


  #The following statement is a piece left from an older data generating procedure that
  #was accidently left here. Without this statement the models created by this
  #function do not coincide with the tests results used in the paper.
  nexp <- sample(2:6,1)

  samples <- globalSamples
  n <- globalVars
  nexp <- globalExp
  
  sanity <- globalSanity

  L$model<-data.createModel(n)

  #returning only the model for statistics calculation
  if(only_model) return(L)

  L$E<-data.createExperiments(n,nexp,sanity)

  L$Cx<-data.getCov(L$model,L$E)

  L$X<-data.samples(L$E,L$Cx,samples)

  #Still creating the sample covariances matrices from prev. data
  L$Cx_sample<-list() 
  for ( i in 1:nexp ) {
    L$Cx_sample[[i]]<-cov(L$X[[i]])
  }


  L
}