data.getCov<-function(M,E) {
  #Creates "accurate" covariance matrices in the given experiments
  #E - a matrix of the experiments
  #M - the linear cyclic model with latent variables

  nexp <- nrow(E)
  n <- ncol(E)
  Cobs <- list()
  for (i in 1:nexp) {
    
    # Compute the full covariance matrix in this experiment
    Jmat <- diag(1*(E[i,]==1))
    ULmat <- diag(1*(E[i,]!=1))
    toteffmat <- solve(diag(n) - ULmat %*% M$B)         
    Cfull <- toteffmat %*% (Jmat + ULmat %*% M$Ce %*% ULmat) %*% t(toteffmat)

    # Fill in the unobserved parts
    Cfull[E[i,]==(-1),]<-NA 
    Cfull[,E[i,]==(-1)]<-NA

    # Save to the list
    Cobs[[i]]<-Cfull
  }
  
  Cobs
}