data.samples<-function(E, Clist, samples) {

  #Creating samples matrices from accurate covariance matrices.
  # E - matrix determining the experiments, see createExperiments.
  # Clist - a list of the accurate covariance matrices
  # samples - number of samples to create per experiment

  n<-ncol(E)
  nexp<-nrow(E)

  Xlist<-list()
  for ( i in 1:nexp) {
    newexp<-E[i,]
    #calculating the square root of the symm. pos definite matrix for efficient sample generation

    EIG<-eigen(Clist[[i]][newexp!=(-1),newexp!=(-1)]) 
    sCxk<-EIG$vectors%*%diag(sqrt(EIG$values))%*%t(EIG$vectors)
  
    X<-array(rnorm(samples*sum(newexp!=(-1))),c(samples,sum(newexp!=(-1))))

    #this makes data with the inputted covariance matrix
    X<-X%*%sCxk	

    #filling up also the unobserved variables in the experiments with NA
    Xbig<-array(NA,c(samples,n))
    Xbig[,newexp!=(-1)]<-X

    Xlist[[i]]<-Xbig
  }


  Xlist
}