knowledge.to.B<-function(knowledge) {
  #Takes a knowledge sturcture of lininf function
  #k(nowledge<-list( T=createParameterTable(n), Z=array(FALSE,c(n_effects,n_effects)),E=array(NA,c(n_effects,times))))
  # and forms a direct effects matrix B from it.

  n<-max(knowledge$T[,2]) #the number of observed variables
  B<-array(NA,c(n,n))

  #put in the direct effect for all variable pairs i->j
  for ( i in 1:n) {
    for( j in (1:n)[-i]) {

      set<-rep(1,n) #in the direct effect only j is unintervened
      set[j]<-0

      #finding the correct row in the parameter table
      #2 is from-variable, 3 is to-variable, 4 is the intervention set converted to a integer
      ii<-which( knowledge$T[,2] == i & knowledge$T[,3] == j & knowledge$T[,4] == bin.to.dec(set) )

      if( knowledge$T[ii,7]==1) { #if the seventh row is 1 the element is zero
        B[j,i]<-0
      } else if ( knowledge$T[ii,8]==1 ) {#if the eight column is 1 the element is nonzero
        B[j,i]<-1
      } else { #otherwise it is unknown
        B[j,i]<-(-1)
      }
    }
  }

  #leaving the diagonal with NA
  B
}