resample<-function(D,times) {
  #Takes data in D and resamples it to create 
  # D -list of data structures D[[i]]$X is the sample data needed for resampling
  # times - howmany times to resamble
  #creating a resampling version of D
  n<-nrow(D[[1]]$Cx)
  for ( i in 1:length(D) ) {
    D[[i]]$R<-array(NA,c(dim(D[[i]]$Cx),times))

    #browser()
    for ( t in 1:times ) {
      if ( !is.infinite(D[[i]]$N) ) {
	#here resampling in bootstrap fashion and creating a new covariance matrix from it
        D[[i]]$R[,,t]<-cov(D[[i]]$X[sample(nrow(D[[i]]$X),nrow(D[[i]]$X),replace=TRUE),])
      } else {
	#if we have infinite number of samples resampling does not change the covariance matrix
        D[[i]]$R[,,t]<-D[[i]]$Cx
      }
    }
    #deleting X from further use
    D[[i]]$X<-NA
  }

  D
}