test.f<-function(Csample, Cinf,significance=0.05,samples,Ei) { 
 #Tests the faithfulness of sample covariance matrix Csample against 
 # the accurate covariance matrix Cinf. 
 #INPUT:
 # Csample - the sampled covariance matrix
 # significance - the significance level used when testing the sample cov matrix independencies
 # samples - number of samples used to create the sample covariance matrix, used for the independence test
 # Ei - 
 # Returns a list
  #extraindependence - TRUE if sample covariance matrix included an additional independence
  #extradependence - TRUE if sample covariance matrix included an additional dependence
  #pmax - largest p value for an extra independence
  #pmin - smallest p value for an extra dependence

 #this just tests the invertibility
  extradependence<-FALSE
  extraindependence<-FALSE
  pmax<-(-Inf)
  pmin<-Inf

  n<-nrow(Csample)
  #eye<-diag(n)

#   for ( i in 0:(2^n - 1 ) ) {
#     Ei<-dec.to.bin(i,n)
# 
#     Csample<-experiment.sample(M,Ei,samples)$Cx
#     Cinf<-experiment.canonical(M,Ei)$Cx
    #assuming here that the model is fa
    for ( j in 1:n ) { #testing j _||_ k 
      for ( k in index(j+1,n) ) {
         for ( ii in 0:(2^(n-2) - 1 ) ) { #ii indexes the conditioning sets, going through all possible
            s<-rep(0,n)
            s[-c(j,k)]<-dec.to.bin(ii,n-2)
            s<-which(s==1)
            if ( any( is.na(Csample[c(j,k,s),] ) ) ) next

	    #calculation the independence in infinite sample limit and with finite samples
            psample<-isIndependent(Csample,j,k,s,samples)
            pinf<-isIndependent(Cinf,j,k,s,Inf)

	    #list the extra independences and dependences in the sample covariance matrix
            if ( psample < significance && pinf > significance ) { 
              cat('Extra dependence:',j,'_N_',k,'|',paste(s,sep=','),'||',paste(which(Ei==1),sep=','),'by',psample,'\n')
              pmin<-min(c(pmin,psample))
              extradependence<-TRUE

            } else if ( psample > significance && pinf < significance ) {
              cat('Extra independence:',j,'_||_',k,'|',paste(s,sep=','),'||',paste(which(Ei==1),sep=','),'by',psample,'\n') 
              pmax<-max(c(pmax,psample))
              extraindependence<-TRUE
            }
         }
      }
    }
 # }

  list(extraindependence=extraindependence,extradependence=extradependence,pmax=pmax,pmin=pmin)
}